<template>
  <div id="unit" class="flex-row">
    <div class="basic-main" @keyup.enter="search">
      <div class="flex" v-if="!show">
        <criteria-paged :model="model" v-ref:paged>
          <criteria partial='criteria' @condition-changed='$parent.selfSearch' v-ref:cri>
            <div novalidate class="form-inline auto" partial>
              <div class="row">
                <div class="col-sm-2 form-group">
                  <label for="startDate" class="font_normal_body">开始日期</label>
                  <datepicker id="startDate" placeholder="开始日期" style="width:60%"
                              v-model="model.startDate"
                              :value.sync="model.startDate"
                              :format="'yyyy-MM-dd HH:mm:ss'"
                              :show-reset-button="true"
                  >
                  </datepicker>
                </div>
                <div class="col-sm-2 form-group">
                  <label for="endDate" class="font_normal_body">结束日期</label>
                  <datepicker id="endDate" placeholder="结束日期" style="width:60%"
                              v-model="model.endDate"
                              :value.sync="model.endDate"
                              :format="'yyyy-MM-dd HH:mm:ss'"
                              :show-reset-button="true"
                  >
                  </datepicker>
                </div>


                <div class="span" style="float:right;">
                  <button class="button_search button_spacing" @click="search()">查询</button>
                  <button class="button_clear button_spacing" @click="$parent.$parent.clear()">清空</button>
                  <export-excel :data="$parent.$parent.getCondition"
                                :field="$parent.$parent.getfield"
                                :footer="$parent.$parent.footer"
                                :header="$parent.$parent.other"
                                sqlurl="api/af-revenue/logic/openapi/exportfile"
                                sql-name="getIncomeGapList"
                                template-name='微信收款汇总导出'
                                :choose-col="true"></export-excel>
                  <print-data :sum-field="$parent.$parent.getfield" :model="$parent.model" :field="$parent.$parent.getfield"
                               :defaultfield="$parent.$parent.defaultfield"
                              titletable="微信收款汇总"
                              :sumsmodel="$parent.$parent.sumsmodel"></print-data>

                  <div style="float: right" class="button_spacing"
                       :class="{'button_shrink_top':$parent.$parent.criteriaShow,'button_shrink_bottom':!$parent.$parent.criteriaShow}"
                       @click="$parent.$parent.hidden()"></div>
                </div>
              </div>
              <div class="row" v-show="$parent.$parent.criteriaShow">

                <res-select-group :show-component="$parent.$parent.orgid" :initres="$parent.$parent.initres"
                                  @re-res="$parent.$parent.getRes" v-ref:sel></res-select-group>
              </div>
            </div>
          </criteria>
          <data-grid :model="model" partial='list' class="list_area table_sy" v-ref:grid :classname="$parent.classname">
            <template partial='head'>
              <tr>
                <th>
                  <nobr>分公司</nobr>
                </th>
                <th>
                  <nobr>日期</nobr>
                </th>
                <th>
                  <nobr>微信收账</nobr>
                </th>
                <th>
                  <nobr>系统收账</nobr>
                </th>
                <th>
                  <nobr>差值</nobr>
                </th>
              </tr>
            </template>
            <template partial='body'>
              <td style="text-align: center;">
                <nobr>{{row.name}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.date}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.weixinfei}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.xitongfei}}</nobr>
              </td>
              <td style="text-align: center;">
                <nobr>{{row.chazhi}}</nobr>
              </td>
            </template>
            <template partial='foot'></template>
          </data-grid>
        </criteria-paged>
        <table class="table-hover">
          <tr style="position: relative" class="table-bordered">
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;color: #5CB95C;font-weight: bold">
              汇总信息
            </td>
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              微信收帐合计:&emsp;{{sumsmodel.weixinfei}}
            </td>
            <td
              style="display: inline-block;width: auto;border-right: 1px solid #F2F6FA;padding: 0px 10px 0px 10px;font-weight: bold">
              系统收账合计:&emsp;{{sumsmodel.xitongfei}}
            </td>

          </tr>
        </table>
      </div>
      <div v-if="show">
        <user-info-detail-manage-new :f_userinfo_id="rowdata.f_userinfo_id" @cancel-main="cancel"></user-info-detail-manage-new>
      </div>
    </div>
  </div>
</template>
<script>
  import {PagedList} from 'vue-client'
  import defaultPrint from '../../config/DefaultPrint'
  import exportConfig from '../../config/exportConfig.js'

  let readySomething = async function (self) {
    self.$refs.paged.$refs.cri.model.startDate = self.$login.toStandardDateString() + ' 00:00:00'
    self.$refs.paged.$refs.cri.model.endDate = self.$login.toStandardDateString() + ' 23:59:59'
    await self.$MagLoadParams.loadParam()
    self.defaultfield = [...self.defaultfield, ...self.config.defaultPrint]
    self.sumsmodel = self.$refs.paged.$refs.grid.model.sums
  }
  export default {
    title: '微信收款汇总',
    name: 'IncomeGapQuery',
    data() {
      return {
        model: new PagedList('api/af-revenue/sql/getIncomeGapList', 30, {
          startDate: 'this.model.startDate',
          endDate: 'this.model.endDate'
        }, {
          weixinfei: 0,
          xitongfei: 0
        }),
        initres: {
          org: [this.$login.f.orgid],
          dep: [],
          user: [],
        },
        other: [],
        footer: [],
        //默认打印列
        defaultfield: [],
        config: {
          defaultPrint: ['date', 'weixinfei', 'chazhi']
        },
        orgid: ['company'],
        gasproperties: [],
        show: false,
        rowdata: {},
        criteriaShow: false,
        orgCondtionStr: '',
        modelval: [],
        printshow: false,
        all: false,
        fields: {},
        thead: '',
        tfoot: '',
        //合计数据
        sumsmodel: {},
        defaultfield: [],
        f_filialeid: this.$login.f.f_orgid,
        f_orgid: this.$login.f.orgid

      }
    },
    ready() {
      readySomething(this)
    },
    methods: {
      getotherfooter() {
        // this.$refs.paged.$refs.cri.$refs.exports.otherData=[];
        // this.$refs.paged.$refs.cri.$refs.exports.footerData=[];
        this.other = [];
        this.footer = [];
        // let exportdata = this.getCondition;
        let otherInData = [];
        otherInData.push(`导出时间: ${this.$login.toStandardTimeString()}`);
        let footerData = [], exportfield = this.getfield;
        footerData.push("合计");
        let self = this;
        for (var field in self.sumsmodel) {
          footerData.push(`${exportfield[field]}合计:${self.sumsmodel[field]}`);
        }
        this.footer.push(footerData);
        this.other.push(otherInData);
      },
      userTypeChange() {
        this.gasproperties = []
        if (this.$refs.paged.$refs.cri.model !== null) {
          this.$refs.paged.$refs.cri.model.f_gasproperties = ''

          console.log(this.$refs.paged.$refs.cri.model.f_user_type[0])
          this.gasproperties = this.$appdata.getParam(this.$refs.paged.$refs.cri.model.f_user_type[0])
        } else {
          this.gasproperties = [{label: '全部', value: ''}]
        }
      },
      search() {
        console.log(bbb)
        this.$refs.paged.$refs.cri.search()
      },
      cancel() {
        this.show = false
      },
      selfSearch(args) {
        args.condition = `${args.condition} ` + this.orgCondtionStr
        console.log(this.orgCondtionStr)

        this.model.search(args.condition, args.model)
        this.sumsmodel = this.$refs.paged.$refs.grid.model.sums
      },
      clear() {
        //清空部门和人员
        this.$refs.paged.$refs.cri.$refs.sel.$children[1].selectres = []
        //部门和人员变为全选
        this.$refs.paged.$refs.cri.$refs.sel.$children[1].$children[0].isSelectAll = false
        this.$refs.paged.$refs.cri.$refs.sel.$children[2].$children[0].isSelectAll = false
        Object.keys(this.$refs.paged.$refs.cri.model).forEach((key) => {
          this.$refs.paged.$refs.cri.model[key] = []
        })
      },
      show() {
        this.criteriaShow = true
      },
      hidden() {
        this.criteriaShow = !this.criteriaShow
      },
      showmsg(obj) {
        this.rowdata = obj
        this.show = true
      },
      getRes(condition, obj) {
        this.orgCondtionStr = condition
        // this.orgname = obj.orgnames[0]
        // this.depname = obj.depnames[0]
      },
      put() {
        // 对Modelval进行排序
        this.sortModelval()
        this.thead = `<tr><th colspan=${this.modelval.length}>非民用用气查询</th></tr><tr>`
        for (let key of this.modelval) {
          this.thead += '<th>' + this.fields[key] + '</th>'
        }
        this.thead += '</tr>'
      },
      print() {
        this.$refs.print.PrintAsFile()
        this.printshow = false
      },
      dealmsg(val) {
        this.rowdata = val
        this.show = true
        val.model = this.model.model
        this.$dispatch('deal-msg', val)
      },
      close() {
        this.printshow = false
        this.all = false
      },
      // 对选择的列进行排序
      sortModelval() {
        let sortModel = []
        Object.keys(this.fields).forEach((key) => {
          if (this.modelval.includes(key)) {
            sortModel.push(key)
          }
        })
        this.modelval = sortModel
        console.log('选择的打印的字段', this.modelval)
      }
    },
    computed: {
      getCondition() {
        return {
          condition: `${this.$refs.paged.$refs.cri.condition}` + this.orgCondtionStr,
          startDate: this.$refs.paged.$refs.cri.model.startDate,
          endDate: this.$refs.paged.$refs.cri.model.endDate
        }
      },
      getfield() {
        return exportConfig.incomeGapConfig
      },
      usertypes() {
        return [{label: ' 全部  ', value: ''}, ...this.$appdata.getParam('用户类型')]
      },
    },
    events: {},
    watch: {
      'all'(val) {
        if (val) {
          this.modelval = this.bodyData
        } else {
          this.modelval = defaultPrint.config
          this.put()
        }
      },
      'modelval.length'() {
        this.put()
      },
      sumsmodel: {
        handler: function (val) {
          this.getotherfooter();
        },
        deep: true
      }
    }
  }
</script>
<style>
  .datapanel {
    color: #333;
    background-color: white;
    padding: 10px 20px;
    border-radius: 15px;
  }
</style>
